local Stamp = CreateFrame("Frame")
Stamp:RegisterEvent("PLAYER_LOGIN")
Stamp:RegisterEvent("BAG_UPDATE")

if not StampDB then StampDB = {} end

local items = {
	"None",
	"|cffff0000SELL|r",
	"|cff00ff00BANK|r",
	"|cffffff00MAIL|r",
	"|cffff00ffKEEP|r",
}

local tempBag,tempSlot,tempButton,tempID

local function markBags()
	if next(ContainerFrame1.bags) then
		for k,v in pairs(ContainerFrame1.bags) do
			local bagSize = _G[v].size
			for i=1,bagSize do
				local itemButton = v.."Item"..i
				local bag = _G[v]:GetID()
				local slot = _G[itemButton]:GetID()
				for k,v in pairs(StampDB) do
					if GetContainerItemID(bag,slot) == k then
						_G[itemButton].text:SetText(items[v])
					end
				end
			end
		end
	end
end

local function clearItems()
	for i=1,12 do
		for ii=1,36 do
			local itemButton = _G["ContainerFrame"..i.."Item"..ii]
			itemButton.text:SetText("")
		end
	end
end

local total = 0
local function onUpdate(self,elapsed)
	total = total + elapsed
	if total >= 0.1 then
		Stamp:SetScript("OnUpdate",nil)
		clearItems()
		markBags()
		total = 0
	end
end


Stamp:SetScript("OnEvent", function(self,event)
	if event == "PLAYER_LOGIN" then
		self:RegisterEvent("BAG_UPDATE")
		self:UnregisterEvent(event)
		
	elseif event == "BAG_UPDATE" then
		clearItems()
		markBags()
	end
end)

hooksecurefunc("ContainerFrameItemButton_OnModifiedClick", function(self,button)
	if IsControlKeyDown() and button == 'RightButton' then
		
		tempBag = self:GetParent():GetID()
		tempSlot = self:GetID()
		tempButton = self:GetName()
		tempID = GetContainerItemID(tempBag,tempSlot)
		
		ToggleDropDownMenu(1, nil, StampDropDown, self:GetName(), 0, 0)
	end
end)

hooksecurefunc("ToggleBackpack", function()
	Stamp:SetScript("OnUpdate",onUpdate)
end)

hooksecurefunc("ToggleBag", function()
	clearItems()
	markBags()
end)

hooksecurefunc("CloseBag", function()
	Stamp:SetScript("OnUpdate",onUpdate)
end)

for i=1,12 do
	for j=1,36 do
		local itemButton = "ContainerFrame"..i.."Item"..j
		local text = Stamp:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
		text:SetParent(itemButton)
		text:SetPoint("TOP",itemButton,"TOP",2,-3)
		_G[itemButton].text = text
	end
end	

if not StampDropDown then
   CreateFrame("Button", "StampDropDown", UIParent, "UIDropDownMenuTemplate")
end

local function OnClick(self)
	UIDropDownMenu_SetSelectedID(StampDropDown, 1)
	if self:GetID() == 1 then
		StampDB[tempID] = nil
		clearItems()
		markBags()
	else
		StampDB[tempID] = self:GetID()
		clearItems()
		markBags()
	end
end

local function initialize(self, level)
	for k,v in pairs(items) do
		info = UIDropDownMenu_CreateInfo()
		info.text = v
		info.value = v
		info.notCheckable = 1
		info.func = OnClick
		UIDropDownMenu_AddButton(info, level)
	end
end

UIDropDownMenu_Initialize(StampDropDown, initialize)
UIDropDownMenu_SetWidth(StampDropDown, 100);
UIDropDownMenu_SetButtonWidth(StampDropDown, 124)
UIDropDownMenu_SetSelectedID(StampDropDown, 1)
UIDropDownMenu_JustifyText(StampDropDown, "LEFT")